<p align="center">
  <img src="https://raw.githubusercontent.com/AbhinavS99/GraphOrchestrator/main/docs/logo.png" alt="GraphOrchestrator Logo" width="300"/>
</p>

<h1 align="center">GraphOrchestrator</h1>

[![CI](https://github.com/AbhinavS99/GraphOrchestrator/actions/workflows/ci.yml/badge.svg)](https://github.com/AbhinavS99/GraphOrchestrator/actions/workflows/ci.yml)
[![codecov](https://codecov.io/gh/AbhinavS99/GraphOrchestrator/graph/badge.svg?token=U69VNUUQ6I)](https://codecov.io/gh/AbhinavS99/GraphOrchestrator)
[![PyPI version](https://badge.fury.io/py/graph-orchestrator.svg)](https://badge.fury.io/py/graph-orchestrator)
[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://github.com/AbhinavS99/GraphOrchestrator/blob/main/LICENSE)

**GraphOrchestrator** is a powerful yet lightweight Python library designed to help you build and execute complex, dynamic workflows as directed graphs. Think of it as your toolkit for crafting intricate decision engines, agent workflows, or even robust data pipelines, all with the elegance of graph-based execution.

## ✨ Purpose

At its core, GraphOrchestrator simplifies the process of defining and running workflows where the flow of operations is determined by a graph. This approach provides exceptional flexibility and clarity, especially when dealing with:

- **Complex Decision Making:** Model intricate decision paths in a visually intuitive graph.
- **Agent Workflows:** Define sequences of actions for autonomous agents.
- **Data Processing Pipelines:** Orchestrate data transformations and processing steps with precision.

## 🚀 Key Features

- **Node-Based Processing:** Define your processing logic as modular **nodes**.
- **Flexible Control Flow:** Guide execution through **concrete and conditional edges**.
- **Decorator Magic:** Use decorators to easily define node actions, routing logic, and aggregators.
- **Robustness Built-In:** Leverage **retry policies** for fault-tolerant execution.
- **Dynamic Branching:** Implement **conditional branching** with ease using routing functions.
- **Parallelism and Aggregation:** Handle **parallel and aggregated state processing** effortlessly.
- **Visualize Your Flow:** Get a clear view of your workflows with **graph visualization** via Matplotlib.
- **Test-Driven Development:** Benefit from **built-in testability** with full unit test coverage.
- **Lightweight and Extensible:** Designed for simplicity, extensibility and easy integration in any project.

## 🛠️ Installation

You can install GraphOrchestrator via pip:



- ✅ **Decorator-driven design** for node actions, routing logic, and aggregators  
- 🔁 **Retry policies** and fault-tolerant execution  
- 🧠 **Conditional branching** using routing functions  
- 🤝 **Parallel and aggregated state processing**  
- 🎨 **Graph visualization** with Matplotlib  
- 🧪 **Built-in testability** with full unit test coverage  

Whether you're designing decision engines, agent workflows, or data pipelines—GraphOrchestrator offers an intuitive and extensible framework for graph-based execution.
